// BitmapAppView.cpp : implementation of the CBitmapAppView class
//

#include "stdafx.h"
#include "BitmapApp.h"

#include "BitmapAppDoc.h"
#include "BitmapAppView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBitmapAppView

IMPLEMENT_DYNCREATE(CBitmapAppView, CView)

BEGIN_MESSAGE_MAP(CBitmapAppView, CView)
	//{{AFX_MSG_MAP(CBitmapAppView)
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBitmapAppView construction/destruction

CBitmapAppView::CBitmapAppView()
{
	// TODO: add construction code here

	m_draw = FALSE;
	srand((unsigned)time(NULL));
}

CBitmapAppView::~CBitmapAppView()
{
	int size = m_pointArray.GetSize();

	for (int x=0; x<size; ++x)
	{
		CPoint* point =
			(CPoint*)m_pointArray.GetAt(x);
		delete point;
	}

	m_pointArray.RemoveAll();
}

BOOL CBitmapAppView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBitmapAppView drawing

void CBitmapAppView::OnDraw(CDC* pDC)
{
	CBitmapAppDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here

	if (m_draw)
    {
        CBrush* pRedBrush = new CBrush(RGB(255,0,0));
        CPen* pThickPen =
            new CPen(PS_SOLID, 3, RGB(0,0,0));
        CBrush* pOldBrush =
            pDC->SelectObject(pRedBrush);
        CPen* pOldPen = pDC->SelectObject(pThickPen);

        int size = m_pointArray.GetSize();

        for (int x=0; x<size; ++x)
        {
            CPoint* point =
                (CPoint*)m_pointArray.GetAt(x);
            int x1 = point->x;
            int y1 = point->y;
            pDC->Rectangle(x1, y1, x1+30, y1+30);
        }

        pDC->TextOut(10, 10, "NO BITMAP");

        pDC->SelectObject(pOldBrush);
        pDC->SelectObject(pOldPen);
		delete pRedBrush;
        delete pThickPen;
    }
    else
    {
        CDC memoryDC;
        memoryDC.CreateCompatibleDC(pDC);
        CBitmap* pOldBitmap =
			memoryDC.SelectObject(&m_bitmap);
        pDC->BitBlt(0, 0, 800, 600,
            &memoryDC, 0, 0, SRCCOPY);
		memoryDC.SelectObject(pOldBitmap);
    }
}

/////////////////////////////////////////////////////////////////////////////
// CBitmapAppView diagnostics

#ifdef _DEBUG
void CBitmapAppView::AssertValid() const
{
	CView::AssertValid();
}

void CBitmapAppView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBitmapAppDoc* CBitmapAppView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBitmapAppDoc)));
	return (CBitmapAppDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBitmapAppView message handlers

int CBitmapAppView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	
    CClientDC windowDC(this);
    m_bitmap.CreateCompatibleBitmap(&windowDC, 800, 600);
    CDC memoryDC;
    memoryDC.CreateCompatibleDC(&windowDC);
    CBitmap* pOldBitmap =
		memoryDC.SelectObject(&m_bitmap);
    CBrush* pWhiteBrush = new CBrush(RGB(255,255,255));
    CRect rect(0, 0, 799, 599);
    memoryDC.FillRect(rect, pWhiteBrush);
    memoryDC.TextOut(10, 10, "BITMAP");
	memoryDC.SelectObject(pOldBitmap);
    delete pWhiteBrush;

	return 0;
}

void CBitmapAppView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
    CClientDC windowDC(this);

    CDC memoryDC;
    memoryDC.CreateCompatibleDC(&windowDC);
    CBitmap* pOldBitmap =
		memoryDC.SelectObject(&m_bitmap);

    CBrush* pRedBrush = new CBrush(RGB(255,0,0));
    CPen* pThickPen =
        new CPen(PS_SOLID, 3, RGB(0,0,0));

    CBrush* pOldMemoryDCBrush =
        memoryDC.SelectObject(pRedBrush);
    CBrush* pOldWindowDCBrush =
        windowDC.SelectObject(pRedBrush);
    CPen* pOldMemoryDCPen =
        memoryDC.SelectObject(pThickPen);
    CPen* pOldWindowDCPen =
        windowDC.SelectObject(pThickPen);

    for (int x=0; x<100; ++x)
    {
        int x1, y1;

        do
        {
            x1 = rand() % 769;
            y1 = rand() % 569;
        }
        while (y1 < 30);

        CPoint* pNewPoint = new CPoint(x1, y1);
        m_pointArray.Add(pNewPoint);

        memoryDC.Rectangle(x1, y1, x1+30, y1+30);
        windowDC.Rectangle(x1, y1, x1+30, y1+30);
    }

    memoryDC.SelectObject(pOldMemoryDCBrush);
    memoryDC.SelectObject(pOldMemoryDCPen);
	memoryDC.SelectObject(pOldBitmap);
    windowDC.SelectObject(pOldWindowDCBrush);
    windowDC.SelectObject(pOldWindowDCPen);

    delete pRedBrush;
    delete pThickPen;

	CView::OnLButtonDown(nFlags, point);
}

void CBitmapAppView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
    m_draw = !m_draw;
    Invalidate();

	CView::OnRButtonDown(nFlags, point);
}
