// BitmapApp2View.cpp : implementation of the CBitmapApp2View class
//

#include "stdafx.h"
#include "BitmapApp2.h"

#include "BitmapApp2Doc.h"
#include "BitmapApp2View.h"
#include "ScaleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBitmapApp2View

IMPLEMENT_DYNCREATE(CBitmapApp2View, CView)

BEGIN_MESSAGE_MAP(CBitmapApp2View, CView)
	//{{AFX_MSG_MAP(CBitmapApp2View)
	ON_COMMAND(ID_SCALE_SETSCALING, OnScaleSetscaling)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBitmapApp2View construction/destruction

CBitmapApp2View::CBitmapApp2View()
{
	// TODO: add construction code here

	m_scale = 1.0;
}

CBitmapApp2View::~CBitmapApp2View()
{
}

BOOL CBitmapApp2View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBitmapApp2View drawing

void CBitmapApp2View::OnDraw(CDC* pDC)
{
	CBitmapApp2Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here

    CDib* pBitmap = pDoc->m_pBitmap;

    if (pBitmap)
    {
        BYTE* pBitmapData = pBitmap->GetData();
        LPBITMAPINFO pBitmapInfo = pBitmap->GetInfo();
        int bitmapHeight = pBitmap->GetHeight();
        int bitmapWidth = pBitmap->GetWidth();
		int scaledWidth = (int)(bitmapWidth * m_scale);
		int scaledHeight = (int)(bitmapHeight * m_scale);

		if (pBitmap->GetRGB()) // Has a color table
		{
            HPALETTE hPalette =
				CreateBitmapPalette(pBitmap);
            HPALETTE hOldPalette =
                ::SelectPalette(pDC->m_hDC, hPalette, FALSE);
            ::RealizePalette(pDC->m_hDC);

            StretchDIBits(pDC->m_hDC,
                10, 10, scaledWidth, scaledHeight,
                0, 0, bitmapWidth, bitmapHeight,
				pBitmapData, pBitmapInfo,
				DIB_RGB_COLORS, SRCCOPY);

            ::SelectPalette(pDC->m_hDC, hOldPalette, FALSE);
            ::DeleteObject(hPalette);
		}
		else
            StretchDIBits(pDC->m_hDC,
                10, 10, scaledWidth, scaledHeight,
                0, 0, bitmapWidth, bitmapHeight,
				pBitmapData, pBitmapInfo,
				DIB_RGB_COLORS, SRCCOPY);

	}
}

/////////////////////////////////////////////////////////////////////////////
// CBitmapApp2View diagnostics

#ifdef _DEBUG
void CBitmapApp2View::AssertValid() const
{
	CView::AssertValid();
}

void CBitmapApp2View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBitmapApp2Doc* CBitmapApp2View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBitmapApp2Doc)));
	return (CBitmapApp2Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBitmapApp2View message handlers

HPALETTE CBitmapApp2View::CreateBitmapPalette(CDib * pBitmap)
{
    struct
    {
        WORD Version;
        WORD NumberOfEntries;
        PALETTEENTRY aEntries[256];
    } palette = { 0x300, 256 };
    
    LPRGBQUAD pRGBTable = pBitmap->GetRGB();
    UINT numberOfColors = pBitmap->GetNumberOfColors();

    for(UINT x=0; x<numberOfColors; ++x)
    {
        palette.aEntries[x].peRed =
            pRGBTable[x].rgbRed;
        palette.aEntries[x].peGreen =
            pRGBTable[x].rgbGreen;
        palette.aEntries[x].peBlue =
            pRGBTable[x].rgbBlue;
        palette.aEntries[x].peFlags = 0;
    }

    HPALETTE hPalette =
        ::CreatePalette((LPLOGPALETTE)&palette);

    return hPalette;
}

void CBitmapApp2View::OnScaleSetscaling() 
{
	// TODO: Add your command handler code here
	
	CScaleDlg dlg(this);
	dlg.m_scale = m_scale;

	int result = dlg.DoModal();

	if (result == IDOK)
	{
		m_scale = dlg.m_scale;
		Invalidate();
	}
}
