// ColorConeAppView.cpp : implementation of the CColorConeAppView class
//

#include "stdafx.h"
#include "ColorConeApp.h"

#include "ColorConeAppDoc.h"
#include "ColorConeAppView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColorConeAppView

IMPLEMENT_DYNCREATE(CColorConeAppView, CView)

BEGIN_MESSAGE_MAP(CColorConeAppView, CView)
	//{{AFX_MSG_MAP(CColorConeAppView)
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorConeAppView construction/destruction

CColorConeAppView::CColorConeAppView()
{
	// TODO: add construction code here

}

CColorConeAppView::~CColorConeAppView()
{
}

BOOL CColorConeAppView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CColorConeAppView drawing

void CColorConeAppView::OnDraw(CDC* pDC)
{
	CColorConeAppDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here

    if (!m_pBackBitmap)
		return;

    BYTE* pBitmapData = m_pBackBitmap->GetData();
    LPBITMAPINFO pBitmapInfo = m_pBackBitmap->GetInfo();

    StretchDIBits(pDC->m_hDC, 0, 0, 500, 300,
        0, 0, 500, 300, pBitmapData, pBitmapInfo,
		DIB_RGB_COLORS, SRCCOPY);
}

/////////////////////////////////////////////////////////////////////////////
// CColorConeAppView diagnostics

#ifdef _DEBUG
void CColorConeAppView::AssertValid() const
{
	CView::AssertValid();
}

void CColorConeAppView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CColorConeAppDoc* CColorConeAppView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CColorConeAppDoc)));
	return (CColorConeAppDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CColorConeAppView message handlers

int CColorConeAppView::OnCreate
    (LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	m_pBackBitmap = new CDib("backgrnd.bmp");
	if (!m_pBackBitmap->IsValid())
		MessageBox("Couldn't find backgrnd.bmp.",
		    "ColorConeApp Error",
			MB_OK | MB_ICONEXCLAMATION);

	m_pConeBitmap = new CDib("cone.bmp");
	if (!m_pConeBitmap->IsValid())
		MessageBox("Couldn't find cone.bmp.",
		    "ColorConeApp Error",
			MB_OK | MB_ICONEXCLAMATION);

	m_pMaskBitmap = new CDib("conemask.bmp");
	if (!m_pMaskBitmap->IsValid())
		MessageBox("Couldn't find conemask.bmp.",
		    "ColorConeApp Error",
			MB_OK | MB_ICONEXCLAMATION);

	return 0;
}

void CColorConeAppView::OnLButtonDown
    (UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here
	//   and/or call default

	CClientDC windowDC(this);

	int destX = point.x - 64;
	int destY = point.y - 64;

    BYTE* pBitmapData = m_pMaskBitmap->GetData();
    LPBITMAPINFO pBitmapInfo = m_pMaskBitmap->GetInfo();

    StretchDIBits(windowDC.m_hDC, destX, destY, 128, 128,
        0, 0, 128, 128, pBitmapData, pBitmapInfo,
		DIB_RGB_COLORS, SRCAND);

    pBitmapData = m_pConeBitmap->GetData();
    pBitmapInfo = m_pConeBitmap->GetInfo();

    StretchDIBits(windowDC.m_hDC, destX, destY, 128, 128,
        0, 0, 128, 128, pBitmapData, pBitmapInfo,
		DIB_RGB_COLORS, SRCPAINT);

	CView::OnLButtonDown(nFlags, point);
}

void CColorConeAppView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: Add your message handler code here

	if (m_pBackBitmap)
		delete m_pBackBitmap;
	if (m_pConeBitmap)
		delete m_pConeBitmap;
	if (m_pMaskBitmap)
		delete m_pMaskBitmap;
}
