// ColorRecAppView.cpp : implementation of the CColorRecAppView class
//

#include "stdafx.h"
#include "ColorRecApp.h"

#include "ColorRecAppDoc.h"
#include "ColorRecAppView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColorRecAppView

IMPLEMENT_DYNCREATE(CColorRecAppView, CView)

BEGIN_MESSAGE_MAP(CColorRecAppView, CView)
	//{{AFX_MSG_MAP(CColorRecAppView)
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorRecAppView construction/destruction

CColorRecAppView::CColorRecAppView()
{
	// TODO: add construction code here

	for (int x=0; x<6; ++x)
	    m_colors[x] = x;
}

CColorRecAppView::~CColorRecAppView()
{

}

BOOL CColorRecAppView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CColorRecAppView drawing

void CColorRecAppView::OnDraw(CDC* pDC)
{
	CColorRecAppDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here

    if (!pBitmap)
		return;

    CBrush blackBrush(RGB(0,0,0));
	pDC->FillRect(CRect(0,0,435,345), &blackBrush);

    BYTE* pBitmapData = pBitmap->GetData();
    LPBITMAPINFO pBitmapInfo = pBitmap->GetInfo();

	for (int x=0; x<6; ++x)
	{
		int destX = x * 128 + 20;
		if (x > 2)
			destX = (x-3) * 128 + 20;

		int destY = 20;
		if (x > 2)
			destY = 148;

		int srcX = m_colors[x] * 128;
		if (m_colors[x] > 2)
		    srcX = (m_colors[x] - 3) * 128;

		int srcY = 0;
		if (m_colors[x] > 2)
			srcY = 128;

        StretchDIBits(pDC->m_hDC, destX, destY, 128, 128,
            srcX, srcY, 128, 128, pBitmapData,
			pBitmapInfo, DIB_RGB_COLORS, SRCCOPY);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CColorRecAppView diagnostics

#ifdef _DEBUG
void CColorRecAppView::AssertValid() const
{
	CView::AssertValid();
}

void CColorRecAppView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CColorRecAppDoc* CColorRecAppView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CColorRecAppDoc)));
	return (CColorRecAppDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CColorRecAppView message handlers

int CColorRecAppView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	pBitmap = new CDib("colorrec.bmp");
	if (!pBitmap->IsValid())
		MessageBox("Couldn't find colorrec.bmp.",
		    "ColorRecApp Error",
			MB_OK | MB_ICONEXCLAMATION);

	return 0;
}

void CColorRecAppView::OnLButtonDown
    (UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here
	//   and/or call default

	if ((point.x > 20) && (point.x < 404) &&
		(point.y > 20) && (point.y < 276))
	{
	    UINT col = ((point.x-20)/128)*128+20;
		UINT row = ((point.y-20)/128)*128+20;
		UINT index = (col/128) + (row/128) * 3;

		UINT temp[6];
		int x;

		for (x=0; x<6; ++x)
		{
			temp[x] = m_colors[index];
			++index;
			if (index > 5)
				index = 0;
		}

		for (x=0; x<6; ++x)
			m_colors[x] = temp[x];

		Invalidate(FALSE);
	}

	CView::OnLButtonDown(nFlags, point);
}

void CColorRecAppView::OnDestroy() 
{
	CView::OnDestroy();
	
	// TODO: Add your message handler code here
	
	if (pBitmap)
		delete pBitmap;
}
